<?php

declare(strict_types=1);

namespace Dedi\SyliusColissimoPlugin\Webservice\Client;

use Dedi\SyliusColissimoPlugin\Webservice\ValueObject\Credentials;

class Client implements ClientInterface
{
    private \SoapClient $client;

    private Credentials $credentials;

    public function __construct(\SoapClient $client, Credentials $credentials)
    {
        $this->client = $client;
        $this->credentials = $credentials;
    }

    public function call(string $method, array $parameters): object
    {
        $parameters = array_merge([
            'accountNumber' => $this->credentials->getAccountNumber(),
            'password' => $this->credentials->getPassword(),
        ], $parameters);

        return $this->client->__soapCall($method, [$parameters], [
            'exceptions' => true,
        ]);
    }
}
